/* Linux-PAM compatibility header. */

#ifndef _PAM_MACROS_H_INCLUDED
#define _PAM_MACROS_H_INCLUDED

#include <string.h>
#include <stdlib.h>

#define _pam_overwrite(x) \
	memset((x), 0, strlen((x)))

#define _pam_drop(p) \
	do { free((p)); (p) = 0; } while (0)

#define _pam_drop_reply(/* struct pam_response* */ reply, /* int */ n_replies) \
do { \
	int reply_i; \
\
	for (reply_i = (n_replies) - 1; reply_i >= 0; --reply_i) \
	if ((reply)[reply_i].resp) { \
		_pam_overwrite((reply)[reply_i].resp); \
		_pam_drop((reply)[reply_i].resp); \
	} \
	_pam_drop((reply)); \
} while (0)

#define x_strdup(s) ((s) ? strdup((s)) : 0)

#ifdef DEBUG

#include <security/pam_appl.h>
#include <security/openpam.h>
#define D(x) D1 x
#define D1(...) openpam_log(PAM_LOG_DEBUG, __VA_ARGS__)

#else /* DEBUG */

#define D(x)

#endif /* DEBUG */

#endif /* _PAM_MACROS_H_INCLUDED */
