Name: openpam
Version: 20040210
Release: alt1

Summary: Pluggable Authentication Modules Library
License: BSD
Group: System/Base
Url: http://openpam.sourceforge.net/

# OpenPAM library soname suffix.
%define	_pam_name_suffix	2

# OpenPAM library package name, used for tracking package dependencies.
%define	libpam		libpam%{_pam_name_suffix}

Source: %name-%version.tar.bz2
Source1: %name.macros
Source2: _pam_macros.h
Source3: pam_misc.h
Source4: PAM-Policy.ALT

Patch1: openpam-20030601-alt-openpam_dynamic.patch
Patch2: openpam-20040210-alt-format.patch
Patch3: openpam-20030609-alt-openpam_module_log.patch
Patch4: openpam-20030609-alt-ENTERP.patch
Patch5: openpam-20030609-alt-openpam_dispatch-debug.patch
Patch6: openpam-20040210-alt-su-fix-warnings.patch

Requires: %libpam = %version-%release

%package -n %libpam
Summary: Shared libraries for running OpenPAM-based software
Group: System/Libraries
PreReq: pam-common >= 1.1
Provides: libpam = %version-%release
Provides: libpam(include)

%package -n %libpam-devel
Summary: Libraries and header files for developing OpenPAM-aware software
Group: Development/C
Provides: libpam-devel = %version-%release
Requires: %libpam = %version-%release
Conflicts: libpam0-devel, libpam-devel < 0:0.75-alt21

%package -n %libpam-devel-static
Summary: Static libraries for developing OpenPAM-aware software
Group: Development/C
Provides: libpam-devel-static = %version-%release
Requires: %libpam-devel = %version-%release
Conflicts: libpam0-devel-static, libpam-devel-static < 0:0.75-alt21

%description
The Pluggable Authentication Modules (PAM) library abstracts a number of
common authentication-related operations and provides a framework for
dynamically loaded modules that implement these operations in various
ways.

%description -n %libpam
The Pluggable Authentication Modules (PAM) library abstracts a number of
common authentication-related operations and provides a framework for
dynamically loaded modules that implement these operations in various
ways.

This package contains shared libraries required for running both
OpenPAM-aware applications and modules for use with OpenPAM.

%description -n %libpam-devel
The Pluggable Authentication Modules (PAM) library abstracts a number of
common authentication-related operations and provides a framework for
dynamically loaded modules that implement these operations in various
ways.

This package contains header files and development libraries used for
building both OpenPAM-aware applications and modules for use with OpenPAM.

%description -n %libpam-devel-static
The Pluggable Authentication Modules (PAM) library abstracts a number of
common authentication-related operations and provides a framework for
dynamically loaded modules that implement these operations in various
ways.

This package contains static libraries used for building statically
linked OpenPAM-aware applications for use with OpenPAM.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

%build
%if_enabled debug
%add_optflags -DDEBUG
%endif
sh -ex ./autogen.sh
%configure \
	--libdir=/lib \
	%{subst_enable static} \
	--with-modules-dir=/lib/security \
	--disable-unversioned-modules \
	#
%make_build

%install
%make_install install DESTDIR=$RPM_BUILD_ROOT

# Install _pam_macros.h and pam_misc.h
for n in _pam_macros.h pam_misc.h; do
	[ ! -f "$RPM_BUILD_ROOT%_includedir/security/$n" ]
	%__install -p -m644 "$RPM_SOURCE_DIR/$n" $RPM_BUILD_ROOT%_includedir/security/
done

# Relocate development libraries from /lib/ to %_libdir/.
%__mkdir_p $RPM_BUILD_ROOT%_libdir
%__mv $RPM_BUILD_ROOT/lib/*.*a $RPM_BUILD_ROOT%_libdir/

for f in $RPM_BUILD_ROOT/lib/libpam*.so; do
	t=`objdump -p "$f" |awk '/SONAME/ {print $2}'`
	[ -n "$t" ]
	%__ln_s ../../lib/"$t" "$RPM_BUILD_ROOT%_libdir/${f##*/}"
	%__rm -f "$f"
done

%__chmod a-x $RPM_BUILD_ROOT/lib{,/security}/*.so.*
%add_findprov_lib_path /lib/security

# OpenPAM-specific rpm macros.
%__install -pD -m644 %SOURCE1 $RPM_BUILD_ROOT%_sysconfdir/rpm/macros.d/pam

# Documentation
%define docdir %_docdir/OpenPAM-%version
%__rm -rf $RPM_BUILD_ROOT%docdir
%__mkdir_p $RPM_BUILD_ROOT%docdir
%__install -p -m644 %SOURCE4 CREDITS LICENSE README RELNOTES HISTORY \
	$RPM_BUILD_ROOT%docdir/
bzip2 -9 $RPM_BUILD_ROOT%docdir/HISTORY

%__mkdir_p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d
for n in libpam{,-devel{,-static}}; do
	echo $n >"$RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%libpam${n#libpam}"
done

%post -n %libpam -p %post_ldconfig
%postun -n %libpam -p %postun_ldconfig

%files -n %libpam
%config %_sysconfdir/buildreqs/packages/substitute.d/%libpam
/lib/lib*.so.*
/lib/security/pam_deny.so.*
/lib/security/pam_permit.so.*
%docdir

%files -n %libpam-devel
%config %_sysconfdir/buildreqs/packages/substitute.d/%libpam-devel
%config %_sysconfdir/rpm/macros.d/pam
%_libdir/lib*.so
%_includedir/*
%_man3dir/*

%if_enabled static
%files -n %libpam-devel-static
%config %_sysconfdir/buildreqs/packages/substitute.d/%libpam-devel-static
%_libdir/lib*.a
%endif # enabled static

%changelog
* Thu Apr 29 2004 Dmitry V. Levin <ldv@altlinux.org> 20040210-alt1
- Updated to 20040210.
- New patches:
  alt-su-fix-warnings
  (deal with compilation warnings generated by new gcc compiler).
- Removed patches:
  alt-openpam_ttyconv (merged upstream).

* Sat Sep 27 2003 Dmitry V. Levin <ldv@altlinux.org> 20030715-alt3
- /etc/rpm/macros.d/pam: reverted previous change.

* Fri Sep 26 2003 Dmitry V. Levin <ldv@altlinux.org> 20030715-alt2
- Fixed bug in openpam_ttyconv(3).
- Updated dependecies:
  + libpam2: provides libpam.
  + libpam2-devel: provides libpam-devel.
  + libpam2-devel-static: provides libpam-devel-static.
- Added buildreq substitution rules.
- /etc/rpm/macros.d/pam: updated (#3050).

* Tue Jul 22 2003 Dmitry V. Levin <ldv@altlinux.org> 20030715-alt1
- Updated to 20030715.
- Removed patches:
  alt-pam_message (merged upstream);
  alt-FREE (merged upstream);
  cvs-ttyconv (merged upstream);
  alt-openpam_ttyconv (merged upstream).
- Updated PAM Policy file.
- Updated rpm macros file.

* Wed Jun 18 2003 Dmitry V. Levin <ldv@altlinux.org> 20030609-alt2
- Added patches:
  alt-openpam_dispatch-debug (more debug);
  cvs-ttyconv, alt-openpam_ttyconv.
- Added pam_misc.h (Linux-PAM compatibility).

* Mon Jun 09 2003 Dmitry V. Levin <ldv@altlinux.org> 20030609-alt1
- Updated to 20030609.
- Removed patches:
  alt-autotools (merged upstream);
  alt-openpam_ttyconv (merged upstream).
- Added patches:
  alt-FREE (bugfix);
  alt-ENTERP (more debug);
  alt-format (GNU C functions format).

* Fri Jun 06 2003 Dmitry V. Levin <ldv@altlinux.org> 20030601-alt3
- Added patches:
  alt-pam_message (change msg type from char* to const char*);
  alt-openpam_module_log (new function);
  alt-openpam_ttyconv (bugfix).
- Added _pam_macros.h (Linux-PAM compatibility).
- Updated PAM Policy file.

* Thu Jun 05 2003 Dmitry V. Levin <ldv@altlinux.org> 20030601-alt2
- Added patches:
  alt-openpam_dynamic (few features);
  alt-autotools (build with GNU autotools instead of pmake).
- Added OpenPAM-specific rpm macros file.

* Mon Jun 02 2003 Dmitry V. Levin <ldv@altlinux.org> 20030601-alt1
- Updated to 20030601.
- Removed patches:
  alt-openpam_configure (merged upstream).

* Wed May 28 2003 Dmitry V. Levin <ldv@altlinux.org> 20030525-alt2
- Added patches:
  alt-openpam_configure (openpam_configure optimization).

* Sun May 25 2003 Dmitry V. Levin <ldv@altlinux.org> 20030525-alt1
- Updated to 20030525.
- Removed patches:
  alt-glibc (merged upstream).

* Mon May 19 2003 Dmitry V. Levin <ldv@altlinux.org> 20030502-alt1
- Initial revision (20030502).
- Added patches:
  alt-glibc (to enable build on ALT Linux).
