/* Linux-PAM compatibility header. */

#ifndef _PAM_MISC_H_INCLUDED
#define _PAM_MISC_H_INCLUDED

#include <security/pam_appl.h>
#include <security/openpam.h>
#include <security/_pam_macros.h>

#define pam_misc_setenv pam_setenv
#define misc_conv openpam_ttyconv

/*
 *  This function takes the supplied environment
 *  and uploads it to be the PAM one.
 */
inline static int
pam_misc_paste_env(pam_handle_t *pamh, const char * const * user_env)
{
	for (; user_env && *user_env; ++user_env)
	{
		int retval = pam_putenv(pamh, *user_env);
		if (retval != PAM_SUCCESS)
			return retval;
	}
	return PAM_SUCCESS;
}

#endif /* _PAM_MISC_H_INCLUDED */
